VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "PlayWave"
   ClientHeight    =   3945
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9270
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3945
   ScaleWidth      =   9270
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox PicProgress 
      BorderStyle     =   0  'None
      Height          =   195
      Index           =   1
      Left            =   90
      ScaleHeight     =   195
      ScaleWidth      =   9060
      TabIndex        =   7
      Top             =   3690
      Width           =   9060
   End
   Begin VB.PictureBox PicProgress 
      BorderStyle     =   0  'None
      Height          =   195
      Index           =   0
      Left            =   90
      ScaleHeight     =   195
      ScaleWidth      =   9060
      TabIndex        =   6
      Top             =   3465
      Width           =   9060
   End
   Begin MSComDlg.CommonDialog CDialog 
      Left            =   4500
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.CommandButton cmdLoadWav 
      Caption         =   "Load"
      Height          =   375
      Left            =   90
      TabIndex        =   5
      Top             =   45
      Width           =   960
   End
   Begin VB.CommandButton cmdPause 
      Caption         =   "Paus&e"
      Height          =   375
      Left            =   2160
      TabIndex        =   4
      Top             =   45
      Width           =   960
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "&Stop"
      Height          =   375
      Left            =   3195
      TabIndex        =   3
      Top             =   45
      Width           =   960
   End
   Begin VB.PictureBox picSeekPos 
      Height          =   195
      Left            =   90
      ScaleHeight     =   135
      ScaleWidth      =   9000
      TabIndex        =   2
      Top             =   495
      Width           =   9060
   End
   Begin VB.PictureBox picWavDisplay 
      Height          =   2625
      Left            =   90
      ScaleHeight     =   2565
      ScaleWidth      =   9000
      TabIndex        =   1
      Top             =   765
      Width           =   9060
   End
   Begin VB.CommandButton cmdPlay 
      Caption         =   "&Play"
      Height          =   375
      Left            =   1125
      TabIndex        =   0
      Top             =   45
      Width           =   960
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Enum IfStringNotFound
    ReturnOriginalStr = 0
    ReturnEmptyStr = 1
End Enum

Private Type Bytes2
    Byte1 As Byte
    Byte2 As Byte
End Type

Private Type IntType
    IntVal As Integer
End Type

Private Const PI As Double = 3.14159265358979 ' 4 * Atn(1)

Private Type FileHeader
    lRiff As Long
    lFileSize As Long
    lWave As Long
    lFormat As Long
    lFormatLength As Long
End Type

Private Type WaveFormat
    wFormatTag As Integer
    nChannels As Integer
    nSamplesPerSec As Long
    nAvgBytesPerSec As Long
    nBlockAlign As Integer
    wBitsPerSample As Integer
End Type

Private Type ChunkHeader
    lType As Long
    lLen As Long
End Type

Private DX As New DirectX8
Private SEnum As DirectSoundEnum8
Private DIC As DirectSound8

' Buffer stuff...
Private Buff As DirectSoundSecondaryBuffer8
Private BuffWave As WAVEFORMATEX
Private BuffDesc As DSBUFFERDESC

Implements DirectXEvent8

Private BuffLen As Long, HalfBuffLen As Long

Private EventsNotify() As DSBPOSITIONNOTIFY
Private EndEvent As Long, MidEvent As Long, StartEvent As Long


Private WaveFileNum As Integer
Private lDataLength As Long
Private lDataStartPos As Long
Private DisplayType As Integer

Private Sub cmdLoadWav_Click()
    Dim Format As WAVEFORMATEX, StrRet As String
    
    On Error GoTo UserCancel
    CDialog.Filter = "WAV files(*.wav)|*.wav"
    CDialog.ShowOpen
    
    If WaveFileNum <> 0 Then Close WaveFileNum
    WaveFileNum = FreeFile
    Open CDialog.FileName For Binary As WaveFileNum
    
    Format = WaveReadFormat(WaveFileNum)
    
    StrRet = Initialize(Format.lSamplesPerSec, Format.nBitsPerSample, Format.nChannels)
    If StrRet <> "" Then
        MsgBox StrRet
        Close WaveFileNum
        WaveFileNum = 0
    Else
        Me.Caption = "PlayWave - " & RightRight(CDialog.FileName, "\")
    End If
    
    picSeekPos.Scale (0, 0)-(100, 1) ' make the scale as a percentage
    
    Exit Sub
UserCancel:
    If Err.Number = 32755 Then
        Err.Clear
    Else
        MsgBox "Error: " & Err.Description, vbCritical, "Error# " & Err.Number
        Err.Clear
    End If
    Exit Sub
End Sub

Private Sub cmdPause_Click()
    If WaveFileNum <> 0 Then SoundStop
End Sub

Private Sub cmdPlay_Click()
    If WaveFileNum <> 0 Then
        SoundPlay
        cmdLoadWav.Enabled = False
    End If
End Sub

Private Sub cmdStop_Click()
    If WaveFileNum <> 0 Then
        SoundStop
        Seek WaveFileNum, lDataStartPos
        cmdLoadWav.Enabled = True
    End If
End Sub

Private Sub DirectXEvent8_DXCallback(ByVal eventid As Long)
    Dim byteBuffer() As Byte
    On Error GoTo Err_Exit
    
    If WaveFileNum = 0 Then Exit Sub
    
    If Loc(WaveFileNum) >= LOF(WaveFileNum) Then
        cmdStop_Click
        Exit Sub
    End If
    
    If Loc(WaveFileNum) + HalfBuffLen > LOF(WaveFileNum) Then
        ReDim byteBuffer(LOF(WaveFileNum) - Loc(WaveFileNum)) ' read only remaining bytes
    Else
        ReDim byteBuffer(HalfBuffLen - 1)
    End If
    
    Get WaveFileNum, , byteBuffer
    
    picSeekPos.Line (0, 0)-(Loc(WaveFileNum) / LOF(WaveFileNum) * 100, 1), picSeekPos.ForeColor, BF
    picSeekPos.Line (Loc(WaveFileNum) / LOF(WaveFileNum) * 100, 0)-(100, 1), picSeekPos.BackColor, BF
    
    Select Case eventid
    Case StartEvent
        Buff.WriteBuffer HalfBuffLen, HalfBuffLen, byteBuffer(0), DSCBLOCK_DEFAULT
    Case MidEvent
        Buff.WriteBuffer 0, HalfBuffLen, byteBuffer(0), DSCBLOCK_DEFAULT
    Case EndEvent
        Debug.Print "EndEvent" ' not used in this example
    End Select
    
    If (eventid = StartEvent Or eventid = MidEvent) And BuffWave.nBitsPerSample = 16 Then
        ShowWAVData16Bit byteBuffer, DisplayType, BuffWave.nChannels
    End If
    
    Exit Sub
Err_Exit:
    Err.Clear
    Exit Sub
End Sub

Private Function Initialize(Optional ByVal SamplesPerSec As Long = 44100, _
                            Optional ByVal BitsPerSample As Integer = 16, _
                            Optional ByVal Channels As Integer = 2) As String
    On Error GoTo ReturnError
    
    Set SEnum = DX.GetDSEnum
    Set DIC = DX.DirectSoundCreate(SEnum.GetGuid(1))
    
    BuffWave.nFormatTag = WAVE_FORMAT_PCM
    BuffWave.nChannels = Channels
    BuffWave.nBitsPerSample = BitsPerSample
    BuffWave.lSamplesPerSec = SamplesPerSec
    
    BuffWave.nBlockAlign = (BuffWave.nBitsPerSample * BuffWave.nChannels) \ 8
    BuffWave.lAvgBytesPerSec = BuffWave.lSamplesPerSec * BuffWave.nBlockAlign
    
    HalfBuffLen = BuffWave.lAvgBytesPerSec / 12 ' this number determines the length of the buffer
    HalfBuffLen = HalfBuffLen + (HalfBuffLen Mod BuffWave.nBlockAlign)
    
    BuffLen = HalfBuffLen * 2
    
    BuffDesc.fxFormat = BuffWave
    BuffDesc.lBufferBytes = BuffLen
    BuffDesc.lFlags = DSBCAPS_CTRLPOSITIONNOTIFY Or DSBCAPS_STICKYFOCUS
    
    DIC.SetCooperativeLevel Me.hWnd, DSSCL_NORMAL
    Set Buff = DIC.CreateSoundBuffer(BuffDesc)
    
    ReDim EventsNotify(0 To 2) As DSBPOSITIONNOTIFY
    
    StartEvent = DX.CreateEvent(Me)
    EventsNotify(0).hEventNotify = StartEvent
    EventsNotify(0).lOffset = 1
    
    MidEvent = DX.CreateEvent(Me)
    EventsNotify(1).hEventNotify = MidEvent
    EventsNotify(1).lOffset = HalfBuffLen
    
    EndEvent = DX.CreateEvent(Me)
    EventsNotify(2).hEventNotify = EndEvent
    EventsNotify(2).lOffset = DSBPN_OFFSETSTOP
    
    Buff.SetNotificationPositions 3, EventsNotify()
    
    Initialize = ""
    Debug.Print "Direct Sound Initialized"
    Exit Function
ReturnError:
    Initialize = "Error: " & Err.Number & vbNewLine & _
        "Desription: " & Err.Description & vbNewLine & _
        "Source: " & Err.Source
    Debug.Print Initialize
    
    Err.Clear
    UninitializeSound
    Exit Function
End Function

Public Function SoundPlay() As Boolean
    On Error GoTo ReturnError
    
    If Not Buff Is Nothing Then Buff.Play DSBPLAY_LOOPING
    
    SoundPlay = True
    Exit Function
ReturnError:
    SoundPlay = False
    Err.Clear
End Function

Public Function SoundStop() As Boolean
    On Error GoTo ReturnError
    
    If Not Buff Is Nothing Then Buff.Stop
    
    SoundStop = True
    Exit Function
ReturnError:
    SoundStop = False
    Err.Clear
End Function

Private Sub UninitializeSound()
    On Error Resume Next
    SoundStop
    DoEvents
    
    HalfBuffLen = 0
    
    DX.DestroyEvent EventsNotify(0).hEventNotify
    DX.DestroyEvent EventsNotify(1).hEventNotify
    DX.DestroyEvent EventsNotify(2).hEventNotify
    
    Erase EventsNotify
    
    Set Buff = Nothing
    Set DIC = Nothing
    Set SEnum = Nothing
End Sub

Private Sub Form_Load()
    DisplayType = 3
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If WaveFileNum <> 0 Then Close WaveFileNum
    UninitializeSound
End Sub

Private Function WaveReadFormat(ByVal InFileNum As Integer) As WAVEFORMATEX
    Dim header As FileHeader
    Dim HdrFormat As WaveFormat
    Dim chunk As ChunkHeader
    Dim by As Byte
    Dim I As Long
    
    Get #InFileNum, 1, header
    
    If header.lRiff <> &H46464952 Then Exit Function   ' Check for "RIFF" tag and exit if not found.
    If header.lWave <> &H45564157 Then Exit Function   ' Check for "WAVE" tag and exit if not found.
    If header.lFormat <> &H20746D66 Then Exit Function ' Check for "fmt " tag and exit if not found.
    
    ' Check format chunk length; if less than 16, it's not PCM data so we can't use it.
    If header.lFormatLength < 16 Then Exit Function
    
    Get #InFileNum, , HdrFormat ' Retrieve format.
    
    ' Seek to next chunk by discarding any format bytes.
    For I = 1 To header.lFormatLength - 16
        Get #InFileNum, , by
    Next
    
    ' Ignore chunks until we get to the "data" chunk.
    Get #InFileNum, , chunk
    Do While chunk.lType <> &H61746164
        For I = 1 To chunk.lLen
            Get #InFileNum, , by
        Next
        Get #InFileNum, , chunk
    Loop
    
    lDataLength = chunk.lLen ' Retrieve the size of the data.
    lDataStartPos = Loc(InFileNum) + 1
    
    ' Fill the returned type with the format information.
    With WaveReadFormat
        .lAvgBytesPerSec = HdrFormat.nAvgBytesPerSec
        .lSamplesPerSec = HdrFormat.nSamplesPerSec
        .nBitsPerSample = HdrFormat.wBitsPerSample
        .nBlockAlign = HdrFormat.nBlockAlign
        .nChannels = HdrFormat.nChannels
        .nFormatTag = HdrFormat.wFormatTag
        .nSize = 0
    End With
End Function

Private Sub picSeekPos_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim SeekPos As Long
    
    If X < 0 Then X = 0
    If X > 100 Then X = 100
    
    If WaveFileNum <> 0 And Button <> 0 Then
        SeekPos = lDataLength * (X / 100#)
        SeekPos = SeekPos - (SeekPos Mod BuffWave.nBlockAlign)
        
        Seek WaveFileNum, lDataStartPos + SeekPos
    End If
End Sub

Private Sub picSeekPos_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    picSeekPos_MouseDown Button, Shift, X, Y
End Sub

Public Sub ShowWAVData16Bit(DataBuff() As Byte, Optional ByVal DispType As Integer, Optional ByVal Channels As Integer = 1)
    Dim HBuffer As Long, K As Long, Col As Long, LAve As Single, RAve As Single
    Dim LX As Single, LY As Single, RX As Single, RY As Single, Stp As Integer
    Dim LInt As Single, RInt As Single, vPI As Single
    Dim Pic1 As Object
    Set Pic1 = picWavDisplay
    
    On Error Resume Next
    HBuffer = UBound(DataBuff)
    
    PicProgress(0).Scale (0, 0)-(HBuffer, 1)
    PicProgress(1).Scale (0, 0)-(HBuffer, 1)
    
    Pic1.PSet (0, 0)
    
    If Channels = 1 Then
        Pic1.Scale (0, -0.5)-(HBuffer, 0.5)
        Stp = 16
        
        Select Case DispType
        Case 0
            Pic1.Cls
            For K = 0 To HBuffer - 2 Step Stp
                LInt = BytesToInt(DataBuff(K), DataBuff(K + 1)) / 65536#
                Pic1.Line -(K, LInt)
                LAve = LAve + (Abs(LInt) * 2)
            Next K
        Case 1
            Pic1.Cls
            For K = 0 To HBuffer - 2 Step Stp
                LInt = BytesToInt(DataBuff(K), DataBuff(K + 1)) / 65536#
                Pic1.Line (LX, 0)-(K, LInt), RGB(255 * (1 - (LInt + 0.5)), 0, 255 * (LInt + 0.5)), BF
                LX = K
                LAve = LAve + (Abs(LInt) * 2)
            Next K
        Case 2
            Pic1.Cls
            Col = RGB(256 * Rnd, 256 * Rnd, 256 * Rnd)
            For K = 0 To HBuffer - 2 Step Stp
                LInt = BytesToInt(DataBuff(K), DataBuff(K + 1)) / 65536#
                Pic1.Line -(K, LInt), RGB(255 * (1 - (LInt + 0.5)), 0, 255 * (LInt + 0.5))
                LAve = LAve + (Abs(LInt) * 2)
            Next K
        Case 3
            Pic1.Cls
            Pic1.Scale (-1, -1)-(1, 1)
            For K = 0 To HBuffer - 2 Step Stp
                LInt = BytesToInt(DataBuff(K), DataBuff(K + 1)) / 65536#
                vPI = (PI / 8) * (K / (HBuffer / 16))
                
                If K = 0 Then
                    Pic1.PSet (Abs(LInt + 0.5) * Cos(vPI), Abs(LInt + 0.5) * Sin(vPI))
                Else
                    Pic1.Line -(Abs(LInt + 0.5) * Cos(vPI), Abs(LInt + 0.5) * Sin(vPI))
                End If
                LAve = LAve + (Abs(LInt) * 2)
            Next K
        End Select
        
        RAve = LAve
    Else
        Pic1.Scale (0, -1)-(HBuffer, 1)
        Stp = 48
        
        Select Case DispType
        Case 0
            Pic1.Cls
            
            For K = 0 To HBuffer - 2 Step Stp
                LInt = BytesToInt(DataBuff(K), DataBuff(K + 1)) / 65536#
                RInt = BytesToInt(DataBuff(K + 2), DataBuff(K + 3)) / 65536#
                
                Pic1.Line (LX, LY)-(K, LInt - 0.5)
                Pic1.Line (RX, RY)-(K, RInt + 0.5)
                
                LX = K
                LY = LInt - 0.5
                
                RX = K
                RY = RInt + 0.5
                
                LAve = LAve + (Abs(LInt) * 2)
                RAve = RAve + (Abs(RInt) * 2)
            Next K
            
            Pic1.Line (LX, LY)-(HBuffer, LY)
            Pic1.Line (RX, RY)-(HBuffer, RY)
        Case 1
            Pic1.Cls
            Stp = 48
            For K = 0 To HBuffer - 2 Step Stp
                LInt = BytesToInt(DataBuff(K), DataBuff(K + 1)) / 65536#
                RInt = BytesToInt(DataBuff(K + 2), DataBuff(K + 3)) / 65536#
                
                Pic1.Line (LX, -0.5)-(K, LInt - 0.5), RGB(255 * (1 - (LInt + 0.5)), 0, 255 * (LInt + 0.5)), BF
                Pic1.Line (LX, 0.5)-(K, RInt + 0.5), RGB(255 * (1 - (RInt + 0.5)), 0, 255 * (RInt + 0.5)), BF
                
                LX = K
                LAve = LAve + (Abs(LInt) * 2)
                RAve = RAve + (Abs(RInt) * 2)
            Next K
        Case 2
            Pic1.Cls
            Col = RGB(256 * Rnd, 256 * Rnd, 256 * Rnd)
            Stp = 48
            For K = 0 To HBuffer - 2 Step Stp
                LInt = BytesToInt(DataBuff(K), DataBuff(K + 1)) / 65536#
                RInt = BytesToInt(DataBuff(K + 2), DataBuff(K + 3)) / 65536#
                
                Pic1.Line (LX, LY)-(K, LInt - 0.5), RGB(255 * (1 - (LInt + 0.5)), 0, 255 * (LInt + 0.5))
                Pic1.Line (RX, RY)-(K, RInt + 0.5), RGB(255 * (1 - (RInt + 0.5)), 0, 255 * (RInt + 0.5))
                
                LX = K
                LY = LInt - 0.5
                
                RX = K
                RY = RInt + 0.5
                
                LAve = LAve + (Abs(LInt) * 2)
                RAve = RAve + (Abs(RInt) * 2)
            Next K
        Case 3
            Dim LPX As Single, LPY As Single, RPX As Single, RPY As Single
            
            Pic1.Cls
            Pic1.Scale (-2, -1)-(2, 1)
            
            For K = 0 To HBuffer - 2 Step Stp * 2
                LInt = BytesToInt(DataBuff(K), DataBuff(K + 1)) / 65536# + 0.5
                RInt = BytesToInt(DataBuff(K + 2), DataBuff(K + 3)) / 65536# + 0.5
                vPI = (PI / 16) * (K / (HBuffer / 32))
                
                If K = 0 Then
                    LX = -1 + Abs(LInt) * Cos(vPI)
                    LY = Abs(LInt) * Sin(vPI)
                    
                    RX = 1 + Abs(RInt) * Cos(vPI)
                    RY = Abs(RInt) * Sin(vPI)
                Else
                    LPX = -1 + Abs(LInt) * Cos(vPI)
                    LPY = Abs(LInt) * Sin(vPI)
                    
                    RPX = 1 + Abs(RInt) * Cos(vPI)
                    RPY = Abs(RInt) * Sin(vPI)
                    
                    Pic1.Line (LX, LY)-(LPX, LPY)
                    Pic1.Line (RX, RY)-(RPX, RPY)
                    
                    LX = LPX
                    LY = LPY
                    RX = RPX
                    RY = RPY
                End If
                
                LAve = LAve + (Abs(LInt - 0.5) * 4)
                RAve = RAve + (Abs(RInt - 0.5) * 4)
            Next K
        End Select
    End If
    
    PicProgress(0).Line (0, 0)-(LAve * Stp * 2, 1), RGB(0, 0, 128), BF
    PicProgress(0).Line (LAve * Stp * 2, 0)-(HBuffer, 1), PicProgress(0).BackColor, BF

    PicProgress(1).Line (0, 0)-(RAve * Stp * 2, 1), RGB(0, 0, 128), BF
    PicProgress(1).Line (RAve * Stp * 2, 0)-(HBuffer, 1), PicProgress(0).BackColor, BF
End Sub

Private Function BytesToInt(ByVal FirstByte As Byte, ByVal SecondByte As Byte) As Long
    Dim B2 As Bytes2, I As IntType
    
    B2.Byte1 = FirstByte
    B2.Byte2 = SecondByte
    
    LSet I = B2
    
    BytesToInt = I.IntVal
End Function

Private Sub picWavDisplay_Click()
    DisplayType = DisplayType + 1
    If DisplayType > 3 Then DisplayType = 0
End Sub

' Search from end to beginning and return the right side of the string
Private Function RightRight(ByRef Str As String, RFind As String, Optional Compare As VbCompareMethod = vbBinaryCompare, Optional RetError As IfStringNotFound = ReturnOriginalStr) As String
    Dim K As Long
    
    K = InStrRev(Str, RFind, , Compare)
    
    If K = 0 Then
        RightRight = IIf(RetError = ReturnOriginalStr, Str, "")
    Else
        RightRight = Mid(Str, K + 1, Len(Str))
    End If
End Function

